/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse COGparse
#define yylex   COGlex
#define yyerror COGerror
#define yylval  COGlval
#define yychar  COGchar
#define yydebug COGdebug
#define yynerrs COGnerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     VMTT_IDENTIFIER = 258,
     VMTT_PLUS_IDENTIFIER = 259,
     VMTT_KEYWORD_BREAK = 260,
     VMTT_KEYWORD_CALL = 261,
     VMTT_KEYWORD_ELSE = 262,
     VMTT_KEYWORD_FOR = 263,
     VMTT_KEYWORD_IF = 264,
     VMTT_KEYWORD_RETURN = 265,
     VMTT_KEYWORD_STOP = 266,
     VMTT_KEYWORD_WHILE = 267,
     VMTT_KEYWORD_DO = 268,
     VMTT_KEYWORD_SYMBOLS = 269,
     VMTT_KEYWORD_CONTINUE = 270,
     VMTT_KEYWORD_CODE = 271,
     VMTT_KEYWORD_END = 272,
     VMTT_KEYWORD_LOCAL = 273,
     VMTT_KEYWORD_DESC = 274,
     VMTT_KEYWORD_MASK = 275,
     VMTT_KEYWORD_LINKID = 276,
     VMTT_KEYWORD_NOLINK = 277,
     VMTT_KEYWORD_GETPARAM = 278,
     VMTT_KEYWORD_GETSENDERID = 279,
     VMTT_KEYWORD_GETSENDERREF = 280,
     VMTT_KEYWORD_GETSENDERTYPE = 281,
     VMTT_KEYWORD_GETSOURCEREF = 282,
     VMTT_KEYWORD_GETSOURCETYPE = 283,
     VMTT_KEYWORD_RETURNEX = 284,
     VMTT_KEYWORD_SLEEP = 285,
     VMTT_TYPE_AI = 286,
     VMTT_TYPE_BOOL = 287,
     VMTT_TYPE_COG = 288,
     VMTT_TYPE_FLEX = 289,
     VMTT_TYPE_FLOAT = 290,
     VMTT_TYPE_INT = 291,
     VMTT_TYPE_KEYFRAME = 292,
     VMTT_TYPE_MATERIAL = 293,
     VMTT_TYPE_MESSAGE = 294,
     VMTT_TYPE_MODEL = 295,
     VMTT_TYPE_SECTOR = 296,
     VMTT_TYPE_SOUND = 297,
     VMTT_TYPE_SURFACE = 298,
     VMTT_TYPE_TEMPLATE = 299,
     VMTT_TYPE_THING = 300,
     VMTT_TYPE_VECTOR = 301,
     VMTT_PUNC_ADD = 302,
     VMTT_PUNC_SUB = 303,
     VMTT_PUNC_MUL = 304,
     VMTT_PUNC_DIV = 305,
     VMTT_PUNC_MOD = 306,
     VMTT_PUNC_AND = 307,
     VMTT_PUNC_OR = 308,
     VMTT_PUNC_XOR = 309,
     VMTT_PUNC_INC = 310,
     VMTT_PUNC_DEC = 311,
     VMTT_PUNC_SHL = 312,
     VMTT_PUNC_SHR = 313,
     VMTT_PUNC_APOS = 314,
     VMTT_PUNC_ASSIGN = 315,
     VMTT_PUNC_ASSIGN_ADD = 316,
     VMTT_PUNC_ASSIGN_SUB = 317,
     VMTT_PUNC_ASSIGN_MUL = 318,
     VMTT_PUNC_ASSIGN_DIV = 319,
     VMTT_PUNC_ASSIGN_MOD = 320,
     VMTT_PUNC_ASSIGN_AND = 321,
     VMTT_PUNC_ASSIGN_OR = 322,
     VMTT_PUNC_ASSIGN_XOR = 323,
     VMTT_PUNC_ASSIGN_SHL = 324,
     VMTT_PUNC_ASSIGN_SHR = 325,
     VMTT_PUNC_EQUALITY_EQ = 326,
     VMTT_PUNC_EQUALITY_NEQ = 327,
     VMTT_PUNC_EQUALITY_GT = 328,
     VMTT_PUNC_EQUALITY_LT = 329,
     VMTT_PUNC_EQUALITY_GTE = 330,
     VMTT_PUNC_EQUALITY_LTE = 331,
     VMTT_PUNC_EQUALITY_AND = 332,
     VMTT_PUNC_EQUALITY_OR = 333,
     VMTT_PUNC_EQUALITY_NOT = 334,
     VMTT_PUNC_LPAREN = 335,
     VMTT_PUNC_RPAREN = 336,
     VMTT_PUNC_LBRACKET = 337,
     VMTT_PUNC_RBRACKET = 338,
     VMTT_PUNC_LBRACE = 339,
     VMTT_PUNC_RBRACE = 340,
     VMTT_PUNC_COMMA = 341,
     VMTT_PUNC_COLON = 342,
     VMTT_PUNC_ENDSTMT = 343,
     VMTT_PUNC_DBLCOLON = 344,
     VMTT_LITERAL_INTEGER = 345,
     VMTT_LITERAL_INTEGER_HEX = 346,
     VMTT_LITERAL_FLOAT = 347,
     VMTT_LITERAL_DOUBLE = 348,
     VMTT_LITERAL_STRING = 349,
     VMTT_LITERAL_FILENAME = 350,
     VMTT_LITERAL_TEMPLATE = 351,
     VMTT_LITERAL_BOOLEAN = 352
   };
#endif
#define VMTT_IDENTIFIER 258
#define VMTT_PLUS_IDENTIFIER 259
#define VMTT_KEYWORD_BREAK 260
#define VMTT_KEYWORD_CALL 261
#define VMTT_KEYWORD_ELSE 262
#define VMTT_KEYWORD_FOR 263
#define VMTT_KEYWORD_IF 264
#define VMTT_KEYWORD_RETURN 265
#define VMTT_KEYWORD_STOP 266
#define VMTT_KEYWORD_WHILE 267
#define VMTT_KEYWORD_DO 268
#define VMTT_KEYWORD_SYMBOLS 269
#define VMTT_KEYWORD_CONTINUE 270
#define VMTT_KEYWORD_CODE 271
#define VMTT_KEYWORD_END 272
#define VMTT_KEYWORD_LOCAL 273
#define VMTT_KEYWORD_DESC 274
#define VMTT_KEYWORD_MASK 275
#define VMTT_KEYWORD_LINKID 276
#define VMTT_KEYWORD_NOLINK 277
#define VMTT_KEYWORD_GETPARAM 278
#define VMTT_KEYWORD_GETSENDERID 279
#define VMTT_KEYWORD_GETSENDERREF 280
#define VMTT_KEYWORD_GETSENDERTYPE 281
#define VMTT_KEYWORD_GETSOURCEREF 282
#define VMTT_KEYWORD_GETSOURCETYPE 283
#define VMTT_KEYWORD_RETURNEX 284
#define VMTT_KEYWORD_SLEEP 285
#define VMTT_TYPE_AI 286
#define VMTT_TYPE_BOOL 287
#define VMTT_TYPE_COG 288
#define VMTT_TYPE_FLEX 289
#define VMTT_TYPE_FLOAT 290
#define VMTT_TYPE_INT 291
#define VMTT_TYPE_KEYFRAME 292
#define VMTT_TYPE_MATERIAL 293
#define VMTT_TYPE_MESSAGE 294
#define VMTT_TYPE_MODEL 295
#define VMTT_TYPE_SECTOR 296
#define VMTT_TYPE_SOUND 297
#define VMTT_TYPE_SURFACE 298
#define VMTT_TYPE_TEMPLATE 299
#define VMTT_TYPE_THING 300
#define VMTT_TYPE_VECTOR 301
#define VMTT_PUNC_ADD 302
#define VMTT_PUNC_SUB 303
#define VMTT_PUNC_MUL 304
#define VMTT_PUNC_DIV 305
#define VMTT_PUNC_MOD 306
#define VMTT_PUNC_AND 307
#define VMTT_PUNC_OR 308
#define VMTT_PUNC_XOR 309
#define VMTT_PUNC_INC 310
#define VMTT_PUNC_DEC 311
#define VMTT_PUNC_SHL 312
#define VMTT_PUNC_SHR 313
#define VMTT_PUNC_APOS 314
#define VMTT_PUNC_ASSIGN 315
#define VMTT_PUNC_ASSIGN_ADD 316
#define VMTT_PUNC_ASSIGN_SUB 317
#define VMTT_PUNC_ASSIGN_MUL 318
#define VMTT_PUNC_ASSIGN_DIV 319
#define VMTT_PUNC_ASSIGN_MOD 320
#define VMTT_PUNC_ASSIGN_AND 321
#define VMTT_PUNC_ASSIGN_OR 322
#define VMTT_PUNC_ASSIGN_XOR 323
#define VMTT_PUNC_ASSIGN_SHL 324
#define VMTT_PUNC_ASSIGN_SHR 325
#define VMTT_PUNC_EQUALITY_EQ 326
#define VMTT_PUNC_EQUALITY_NEQ 327
#define VMTT_PUNC_EQUALITY_GT 328
#define VMTT_PUNC_EQUALITY_LT 329
#define VMTT_PUNC_EQUALITY_GTE 330
#define VMTT_PUNC_EQUALITY_LTE 331
#define VMTT_PUNC_EQUALITY_AND 332
#define VMTT_PUNC_EQUALITY_OR 333
#define VMTT_PUNC_EQUALITY_NOT 334
#define VMTT_PUNC_LPAREN 335
#define VMTT_PUNC_RPAREN 336
#define VMTT_PUNC_LBRACKET 337
#define VMTT_PUNC_RBRACKET 338
#define VMTT_PUNC_LBRACE 339
#define VMTT_PUNC_RBRACE 340
#define VMTT_PUNC_COMMA 341
#define VMTT_PUNC_COLON 342
#define VMTT_PUNC_ENDSTMT 343
#define VMTT_PUNC_DBLCOLON 344
#define VMTT_LITERAL_INTEGER 345
#define VMTT_LITERAL_INTEGER_HEX 346
#define VMTT_LITERAL_FLOAT 347
#define VMTT_LITERAL_DOUBLE 348
#define VMTT_LITERAL_STRING 349
#define VMTT_LITERAL_FILENAME 350
#define VMTT_LITERAL_TEMPLATE 351
#define VMTT_LITERAL_BOOLEAN 352




/* Copy the first part of user declarations.  */
#line 3 "c:\\Cvs\\sith\\cog.y"

#include "stdafx.h"

#include "vmtype.h"
#include "opcodes.h"
#include "instruction.h"
#include "vmheap.h"
#include "stackmachine.h"
#include "coglib.h"
#include "vector.h"

#include "cog.y.hpp"

using namespace Sith::COG;

int yyerror(char *s);
int yylex(void);

extern char *yytext;

extern int COGlineno;

VMType yyVMTbuf;

std::stack<int> BackPatchStack;

int yyArgCtr = 0;
std::stack<int> RecurArgCtr;

Sith::COG::VMHeap::SymbolExtensionTable ExtTab;

extern StackMachine* GlobalStackMachine;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 38 "c:\\Cvs\\sith\\cog.y"
typedef union YYSTYPE { int Integer; float Float; double Double; bool Boolean; char *String; Sith::COG::VMTypeCode TypeCode; } YYSTYPE;
/* Line 191 of yacc.c.  */
#line 315 "cog.y.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 327 "cog.y.cpp"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  98
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   761

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  98
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  48
/* YYNRULES -- Number of rules. */
#define YYNRULES  116
/* YYNRULES -- Number of states. */
#define YYNSTATES  209

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   352

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     8,     9,    11,    13,    15,    17,
      19,    21,    23,    25,    27,    29,    31,    33,    39,    41,
      43,    47,    49,    53,    55,    60,    64,    68,    72,    73,
      79,    80,    86,    87,    93,    94,    99,   100,   106,   109,
     112,   115,   118,   120,   124,   126,   129,   132,   135,   138,
     140,   144,   148,   152,   154,   158,   162,   164,   168,   172,
     174,   178,   182,   186,   190,   192,   196,   200,   202,   206,
     208,   212,   214,   218,   220,   224,   226,   230,   232,   239,
     243,   249,   251,   255,   257,   259,   261,   263,   265,   267,
     270,   273,   276,   280,   282,   285,   287,   290,   295,   298,
     301,   303,   306,   308,   313,   315,   319,   322,   326,   329,
     332,   340,   343,   346,   349,   352,   356
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      99,     0,    -1,   132,    17,    -1,   132,    -1,    -1,    90,
      -1,    91,    -1,    92,    -1,    93,    -1,    94,    -1,    97,
      -1,   101,    -1,   100,    -1,   100,    -1,   103,    -1,   101,
      -1,   102,    -1,    59,   104,   104,   104,    59,    -1,     3,
      -1,   106,    -1,   106,    89,   106,    -1,   105,    -1,    80,
     127,    81,    -1,   107,    -1,   106,    82,   127,    83,    -1,
      24,    80,    81,    -1,    25,    80,    81,    -1,    27,    80,
      81,    -1,    -1,    23,    80,   109,   114,    81,    -1,    -1,
      29,    80,   110,   114,    81,    -1,    -1,    30,    80,   111,
     114,    81,    -1,    -1,     3,    80,   112,    81,    -1,    -1,
       3,    80,   113,   114,    81,    -1,     3,    55,    -1,     3,
      56,    -1,   108,    55,    -1,   108,    56,    -1,   126,    -1,
     114,    86,   126,    -1,   108,    -1,    48,   116,    -1,    79,
     116,    -1,    55,     3,    -1,    56,     3,    -1,   115,    -1,
     116,    49,   115,    -1,   116,    50,   115,    -1,   116,    51,
     115,    -1,   116,    -1,   117,    47,   116,    -1,   117,    48,
     116,    -1,   117,    -1,   118,    57,   117,    -1,   118,    58,
     117,    -1,   118,    -1,   119,    74,   118,    -1,   119,    73,
     118,    -1,   119,    76,   118,    -1,   119,    75,   118,    -1,
     119,    -1,   120,    71,   119,    -1,   120,    72,   119,    -1,
     120,    -1,   121,    52,   120,    -1,   121,    -1,   122,    54,
     121,    -1,   122,    -1,   123,    53,   122,    -1,   123,    -1,
     124,    77,   123,    -1,   124,    -1,   125,    78,   124,    -1,
     125,    -1,   106,    82,   127,    83,    60,   126,    -1,   106,
      60,   126,    -1,   106,    89,   106,    60,   126,    -1,   126,
      -1,   127,    86,   126,    -1,   130,    -1,   131,    -1,   133,
      -1,   137,    -1,   144,    -1,   145,    -1,   106,    87,    -1,
     129,   128,    -1,    84,    85,    -1,    84,   132,    85,    -1,
     128,    -1,   132,   128,    -1,    88,    -1,   127,    88,    -1,
       9,    80,   127,    81,    -1,   134,   128,    -1,   135,     7,
      -1,   135,    -1,   136,   128,    -1,    12,    -1,   138,    80,
     127,    81,    -1,    13,    -1,     8,    80,   133,    -1,   141,
     133,    -1,   142,   127,    81,    -1,   142,    81,    -1,   139,
     128,    -1,   140,   128,    12,    80,   127,    81,    88,    -1,
     143,   128,    -1,    15,    88,    -1,     5,    88,    -1,    10,
      88,    -1,    10,   127,    88,    -1,     6,     3,    88,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    88,    88,    89,    90,    96,    97,   101,   102,   106,
     110,   114,   115,   119,   120,   121,   122,   166,   173,   177,
     189,   212,   213,   217,   218,   222,   227,   232,   237,   237,
     253,   253,   269,   269,   285,   285,   305,   305,   325,   332,
     339,   340,   344,   345,   349,   350,   355,   356,   363,   373,
     374,   375,   376,   380,   381,   382,   386,   387,   388,   392,
     393,   394,   395,   396,   400,   401,   402,   406,   407,   411,
     412,   416,   417,   421,   422,   426,   427,   431,   432,   436,
     441,   461,   462,   466,   467,   468,   469,   470,   471,   475,
     490,   494,   495,   499,   500,   504,   505,   516,   523,   533,
     540,   553,   566,   570,   579,   587,   594,   605,   625,   641,
     667,   688,   717,   743,   750,   751,   752
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "VMTT_IDENTIFIER", "VMTT_PLUS_IDENTIFIER", 
  "VMTT_KEYWORD_BREAK", "VMTT_KEYWORD_CALL", "VMTT_KEYWORD_ELSE", 
  "VMTT_KEYWORD_FOR", "VMTT_KEYWORD_IF", "VMTT_KEYWORD_RETURN", 
  "VMTT_KEYWORD_STOP", "VMTT_KEYWORD_WHILE", "VMTT_KEYWORD_DO", 
  "VMTT_KEYWORD_SYMBOLS", "VMTT_KEYWORD_CONTINUE", "VMTT_KEYWORD_CODE", 
  "VMTT_KEYWORD_END", "VMTT_KEYWORD_LOCAL", "VMTT_KEYWORD_DESC", 
  "VMTT_KEYWORD_MASK", "VMTT_KEYWORD_LINKID", "VMTT_KEYWORD_NOLINK", 
  "VMTT_KEYWORD_GETPARAM", "VMTT_KEYWORD_GETSENDERID", 
  "VMTT_KEYWORD_GETSENDERREF", "VMTT_KEYWORD_GETSENDERTYPE", 
  "VMTT_KEYWORD_GETSOURCEREF", "VMTT_KEYWORD_GETSOURCETYPE", 
  "VMTT_KEYWORD_RETURNEX", "VMTT_KEYWORD_SLEEP", "VMTT_TYPE_AI", 
  "VMTT_TYPE_BOOL", "VMTT_TYPE_COG", "VMTT_TYPE_FLEX", "VMTT_TYPE_FLOAT", 
  "VMTT_TYPE_INT", "VMTT_TYPE_KEYFRAME", "VMTT_TYPE_MATERIAL", 
  "VMTT_TYPE_MESSAGE", "VMTT_TYPE_MODEL", "VMTT_TYPE_SECTOR", 
  "VMTT_TYPE_SOUND", "VMTT_TYPE_SURFACE", "VMTT_TYPE_TEMPLATE", 
  "VMTT_TYPE_THING", "VMTT_TYPE_VECTOR", "VMTT_PUNC_ADD", "VMTT_PUNC_SUB", 
  "VMTT_PUNC_MUL", "VMTT_PUNC_DIV", "VMTT_PUNC_MOD", "VMTT_PUNC_AND", 
  "VMTT_PUNC_OR", "VMTT_PUNC_XOR", "VMTT_PUNC_INC", "VMTT_PUNC_DEC", 
  "VMTT_PUNC_SHL", "VMTT_PUNC_SHR", "VMTT_PUNC_APOS", "VMTT_PUNC_ASSIGN", 
  "VMTT_PUNC_ASSIGN_ADD", "VMTT_PUNC_ASSIGN_SUB", "VMTT_PUNC_ASSIGN_MUL", 
  "VMTT_PUNC_ASSIGN_DIV", "VMTT_PUNC_ASSIGN_MOD", "VMTT_PUNC_ASSIGN_AND", 
  "VMTT_PUNC_ASSIGN_OR", "VMTT_PUNC_ASSIGN_XOR", "VMTT_PUNC_ASSIGN_SHL", 
  "VMTT_PUNC_ASSIGN_SHR", "VMTT_PUNC_EQUALITY_EQ", 
  "VMTT_PUNC_EQUALITY_NEQ", "VMTT_PUNC_EQUALITY_GT", 
  "VMTT_PUNC_EQUALITY_LT", "VMTT_PUNC_EQUALITY_GTE", 
  "VMTT_PUNC_EQUALITY_LTE", "VMTT_PUNC_EQUALITY_AND", 
  "VMTT_PUNC_EQUALITY_OR", "VMTT_PUNC_EQUALITY_NOT", "VMTT_PUNC_LPAREN", 
  "VMTT_PUNC_RPAREN", "VMTT_PUNC_LBRACKET", "VMTT_PUNC_RBRACKET", 
  "VMTT_PUNC_LBRACE", "VMTT_PUNC_RBRACE", "VMTT_PUNC_COMMA", 
  "VMTT_PUNC_COLON", "VMTT_PUNC_ENDSTMT", "VMTT_PUNC_DBLCOLON", 
  "VMTT_LITERAL_INTEGER", "VMTT_LITERAL_INTEGER_HEX", 
  "VMTT_LITERAL_FLOAT", "VMTT_LITERAL_DOUBLE", "VMTT_LITERAL_STRING", 
  "VMTT_LITERAL_FILENAME", "VMTT_LITERAL_TEMPLATE", 
  "VMTT_LITERAL_BOOLEAN", "$accept", "cog_script", "integer_literal", 
  "float_literal", "string_literal", "boolean_literal", 
  "vector_literal_element", "literal", "identifier", "primary_expression", 
  "postfix_expression", "@1", "@2", "@3", "@4", "@5", 
  "argument_expression_list", "unary_expression", 
  "multiplicative_expression", "additive_expression", "shift_expression", 
  "relational_expression", "equality_expression", "and_expression", 
  "exclusive_or_expression", "inclusive_or_expression", 
  "logical_and_expression", "logical_or_expression", 
  "assignment_expression", "expression", "statement", "message_label", 
  "labeled_statement", "compound_statement", "statement_list", 
  "expression_statement", "if_block_header", "if_block", "else_block", 
  "selection_statement", "while_statement_header", "while_statement", 
  "do_statement", "for_statement_header", "for_statement_block", 
  "for_statement", "iteration_statement", "jump_statement", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    98,    99,    99,    99,   100,   100,   101,   101,   102,
     103,   104,   104,   105,   105,   105,   105,   105,   106,   107,
     107,   107,   107,   108,   108,   108,   108,   108,   109,   108,
     110,   108,   111,   108,   112,   108,   113,   108,   108,   108,
     108,   108,   114,   114,   115,   115,   115,   115,   115,   116,
     116,   116,   116,   117,   117,   117,   118,   118,   118,   119,
     119,   119,   119,   119,   120,   120,   120,   121,   121,   122,
     122,   123,   123,   124,   124,   125,   125,   126,   126,   126,
     126,   127,   127,   128,   128,   128,   128,   128,   128,   129,
     130,   131,   131,   132,   132,   133,   133,   134,   135,   136,
     137,   137,   138,   139,   140,   141,   142,   143,   143,   144,
     144,   144,   145,   145,   145,   145,   145
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     1,     0,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     1,     1,
       3,     1,     3,     1,     4,     3,     3,     3,     0,     5,
       0,     5,     0,     5,     0,     4,     0,     5,     2,     2,
       2,     2,     1,     3,     1,     2,     2,     2,     2,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     1,
       3,     3,     3,     3,     1,     3,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     6,     3,
       5,     1,     3,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     3,     1,     2,     1,     2,     4,     2,     2,
       1,     2,     1,     4,     1,     3,     2,     3,     2,     2,
       7,     2,     2,     2,     2,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       4,    18,     0,     0,     0,     0,     0,   102,   104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    95,     5,     6,     7,     8,     9,    10,
       0,    13,    15,    16,    14,    21,    19,    23,    44,    49,
      53,    56,    59,    64,    67,    69,    71,    73,    75,    77,
      81,     0,    93,     0,    83,    84,     3,    85,     0,   100,
       0,    86,     0,     0,     0,     0,     0,     0,    87,    88,
      38,    39,    36,   113,     0,     0,     0,   114,    19,     0,
     112,    28,     0,     0,     0,    30,    32,    19,    45,    47,
      48,    12,    11,     0,    46,     0,    91,     0,     1,     0,
       0,    89,     0,    40,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    96,    90,     2,    94,    98,    99,
     101,     0,   109,     0,   106,   108,     0,   111,     0,     0,
     116,   105,     0,   115,     0,    25,    26,    27,     0,     0,
       0,     0,     0,    22,    92,    79,     0,    18,    20,    50,
      51,    52,    54,    55,    57,    58,    61,    60,    63,    62,
      65,    66,    68,    70,    72,    74,    76,    82,     0,     0,
     107,    35,     0,    42,    97,     0,     0,     0,     0,    20,
       0,    24,     0,   103,     0,    37,     0,    29,    31,    33,
      24,    17,     0,    80,     0,    43,    78,     0,   110
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    30,    31,    32,    33,    34,    93,    35,    87,    37,
      38,   144,   148,   149,   138,   139,   182,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -125
static const short yypact[] =
{
     474,    -6,   -80,    42,    10,    14,   490,  -125,  -125,     8,
      21,    27,    47,    50,    54,    55,   664,    95,   135,    -4,
     664,   664,   195,  -125,  -125,  -125,  -125,  -125,  -125,  -125,
     140,  -125,  -125,  -125,  -125,  -125,   -55,  -125,    17,  -125,
      32,    56,    67,    36,   -17,    89,    88,    90,    69,    74,
    -125,   -77,  -125,   474,  -125,  -125,   288,  -125,   474,   146,
     474,  -125,    75,   474,   474,   569,   616,   474,  -125,  -125,
    -125,  -125,    66,  -125,    68,   569,   664,  -125,   -41,     5,
    -125,  -125,    73,    76,    77,  -125,  -125,   -75,    32,  -125,
    -125,  -125,  -125,    -4,    32,   -58,  -125,   381,  -125,   664,
     664,  -125,   156,  -125,  -125,   664,   664,   664,   664,   664,
     664,   664,   664,   664,   664,   664,   664,   664,   664,   664,
     664,   664,   664,   664,  -125,  -125,  -125,  -125,  -125,  -125,
    -125,   664,  -125,   148,  -125,  -125,   -51,  -125,    81,   664,
    -125,  -125,   -43,  -125,   664,  -125,  -125,  -125,   664,   664,
     664,   156,    -4,  -125,  -125,  -125,   -68,  -125,   103,  -125,
    -125,  -125,    32,    32,    56,    56,    67,    67,    67,    67,
      36,    36,   -17,    89,    88,    90,    69,  -125,   -42,    84,
    -125,  -125,   -39,  -125,  -125,   -35,   -29,    -2,   -24,  -125,
     107,   108,   664,  -125,   664,  -125,   664,  -125,  -125,  -125,
    -125,  -125,   664,  -125,    -1,  -125,  -125,    79,  -125
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -125,  -125,   -16,   -15,  -125,  -125,   -83,  -125,     0,  -125,
    -125,  -125,  -125,  -125,  -125,  -125,  -124,     9,    -3,    18,
       7,    16,    51,    53,    57,    49,    52,  -125,   -31,    -5,
     -27,  -125,  -125,  -125,   151,   -63,  -125,  -125,  -125,  -125,
    -125,  -125,  -125,  -125,  -125,  -125,  -125,  -125
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -35
static const short yytable[] =
{
      36,    79,   134,    91,    92,    99,    78,   150,    73,   123,
     152,   124,   141,    88,   151,   191,    95,    94,   123,    99,
     185,    78,    36,   153,   186,   187,   125,   100,   123,   127,
     180,   128,   101,   130,   102,   123,   132,   133,   184,   193,
     137,   100,   195,   123,   123,    74,   197,   196,   102,    70,
      71,   196,   198,    36,   116,   117,    36,   196,    36,   200,
      36,   136,   123,    36,    36,    78,    78,    36,   155,   190,
     127,   142,   103,   104,    72,    78,    78,    91,    92,   199,
     207,   105,   106,   107,   196,   123,    24,    25,    26,    27,
      75,   123,   177,   143,    76,   156,    80,    36,    89,    78,
      78,    81,   158,   108,   109,   162,   163,    82,   183,   112,
     113,   114,   115,   183,   159,   160,   161,   183,   183,   166,
     167,   168,   169,    78,   110,   111,   178,    83,   164,   165,
      84,    78,   170,   171,    85,    86,    91,    92,    90,    78,
      98,   118,   119,   120,    78,   188,   121,   -34,    78,    78,
      78,   189,   122,   129,   145,   131,   140,   146,   147,   157,
     179,   203,   181,   192,   194,   205,   201,   208,   202,   172,
     175,   206,   173,    97,   176,     0,     0,   174,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   204,
       0,     0,    78,     0,    78,     0,    78,     0,     1,     0,
       2,     3,    78,     4,     5,     6,     0,     7,     8,     0,
       9,     0,     0,     0,     0,     0,     0,     0,    10,    11,
      12,     0,    13,     0,    14,    15,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,     0,     0,     0,     0,     0,
      17,    18,     0,     0,    19,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,    21,     0,     0,     0,    22,
      96,     0,     0,    23,     0,    24,    25,    26,    27,    28,
       0,     1,    29,     2,     3,     0,     4,     5,     6,     0,
       7,     8,     0,     9,     0,   126,     0,     0,     0,     0,
       0,    10,    11,    12,     0,    13,     0,    14,    15,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,     0,     0,     0,
       0,     0,     0,    17,    18,     0,     0,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    20,    21,     0,
       0,     0,    22,     0,     0,     0,    23,     0,    24,    25,
      26,    27,    28,     0,     1,    29,     2,     3,     0,     4,
       5,     6,     0,     7,     8,     0,     9,     0,     0,     0,
       0,     0,     0,     0,    10,    11,    12,     0,    13,     0,
      14,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
       0,     0,     0,     0,     0,     0,    17,    18,     0,     0,
      19,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      20,    21,     0,     0,     0,    22,   154,     0,     0,    23,
       0,    24,    25,    26,    27,    28,     0,     1,    29,     2,
       3,     0,     4,     5,     6,     0,     7,     8,     0,     9,
       0,     0,     0,     1,     0,     0,     0,    10,    11,    12,
       0,    13,     0,    14,    15,     0,     0,     0,     0,     0,
       0,     0,     0,    10,    11,    12,     0,    13,     0,    14,
      15,     0,    16,     0,     0,     0,     0,     0,     0,    17,
      18,     0,     0,    19,     0,     0,     0,     0,    16,     0,
       0,     0,     0,     0,     0,    17,    18,     0,     0,    19,
       0,     0,     0,    20,    21,     0,     0,     0,    22,     0,
       0,     0,    23,     0,    24,    25,    26,    27,    28,    20,
      21,    29,     1,     0,     0,     0,     0,     0,    77,     0,
      24,    25,    26,    27,    28,     0,     0,    29,     0,     0,
       0,     0,    10,    11,    12,     0,    13,     0,    14,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    16,     0,     1,
       0,     0,     0,     0,    17,    18,     0,     0,    19,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    10,
      11,    12,     0,    13,     0,    14,    15,     0,    20,    21,
       0,     0,     0,     0,     0,     0,     0,    23,     0,    24,
      25,    26,    27,    28,    16,     0,    29,     1,     0,     0,
       0,    17,    18,     0,     0,    19,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    10,    11,    12,
       0,    13,     0,    14,    15,    20,    21,   135,     0,     0,
       0,     0,     0,     0,     0,     0,    24,    25,    26,    27,
      28,     0,    16,    29,     0,     0,     0,     0,     0,    17,
      18,     0,     0,    19,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    24,    25,    26,    27,    28,     0,
       0,    29
};

static const short yycheck[] =
{
       0,     6,    65,    19,    19,    60,     6,    82,    88,    86,
      93,    88,    75,    16,    89,    83,    21,    20,    86,    60,
     144,    21,    22,    81,   148,   149,    53,    82,    86,    56,
      81,    58,    87,    60,    89,    86,    63,    64,    81,    81,
      67,    82,    81,    86,    86,     3,    81,    86,    89,    55,
      56,    86,    81,    53,    71,    72,    56,    86,    58,    83,
      60,    66,    86,    63,    64,    65,    66,    67,    99,   152,
      97,    76,    55,    56,    80,    75,    76,    93,    93,    81,
      81,    49,    50,    51,    86,    86,    90,    91,    92,    93,
      80,    86,   123,    88,    80,   100,    88,    97,     3,    99,
     100,    80,   102,    47,    48,   108,   109,    80,   139,    73,
      74,    75,    76,   144,   105,   106,   107,   148,   149,   112,
     113,   114,   115,   123,    57,    58,   131,    80,   110,   111,
      80,   131,   116,   117,    80,    80,   152,   152,     3,   139,
       0,    52,    54,    53,   144,   150,    77,    81,   148,   149,
     150,   151,    78,     7,    81,    80,    88,    81,    81,     3,
      12,   192,    81,    60,    80,   196,    59,    88,    60,   118,
     121,   202,   119,    22,   122,    -1,    -1,   120,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   194,
      -1,    -1,   192,    -1,   194,    -1,   196,    -1,     3,    -1,
       5,     6,   202,     8,     9,    10,    -1,    12,    13,    -1,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    -1,    27,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    56,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    84,
      85,    -1,    -1,    88,    -1,    90,    91,    92,    93,    94,
      -1,     3,    97,     5,     6,    -1,     8,     9,    10,    -1,
      12,    13,    -1,    15,    -1,    17,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    -1,    27,    -1,    29,    30,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    -1,
      -1,    -1,    84,    -1,    -1,    -1,    88,    -1,    90,    91,
      92,    93,    94,    -1,     3,    97,     5,     6,    -1,     8,
       9,    10,    -1,    12,    13,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    -1,    27,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      79,    80,    -1,    -1,    -1,    84,    85,    -1,    -1,    88,
      -1,    90,    91,    92,    93,    94,    -1,     3,    97,     5,
       6,    -1,     8,     9,    10,    -1,    12,    13,    -1,    15,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    23,    24,    25,
      -1,    27,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    -1,    27,    -1,    29,
      30,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      56,    -1,    -1,    59,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    -1,    59,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    84,    -1,
      -1,    -1,    88,    -1,    90,    91,    92,    93,    94,    79,
      80,    97,     3,    -1,    -1,    -1,    -1,    -1,    88,    -1,
      90,    91,    92,    93,    94,    -1,    -1,    97,    -1,    -1,
      -1,    -1,    23,    24,    25,    -1,    27,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,     3,
      -1,    -1,    -1,    -1,    55,    56,    -1,    -1,    59,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    -1,    27,    -1,    29,    30,    -1,    79,    80,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    -1,    90,
      91,    92,    93,    94,    48,    -1,    97,     3,    -1,    -1,
      -1,    55,    56,    -1,    -1,    59,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      -1,    27,    -1,    29,    30,    79,    80,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    92,    93,
      94,    -1,    48,    97,    -1,    -1,    -1,    -1,    -1,    55,
      56,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    90,    91,    92,    93,    94,    -1,
      -1,    97
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     5,     6,     8,     9,    10,    12,    13,    15,
      23,    24,    25,    27,    29,    30,    48,    55,    56,    59,
      79,    80,    84,    88,    90,    91,    92,    93,    94,    97,
      99,   100,   101,   102,   103,   105,   106,   107,   108,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
      55,    56,    80,    88,     3,    80,    80,    88,   106,   127,
      88,    80,    80,    80,    80,    80,    80,   106,   116,     3,
       3,   100,   101,   104,   116,   127,    85,   132,     0,    60,
      82,    87,    89,    55,    56,    49,    50,    51,    47,    48,
      57,    58,    73,    74,    75,    76,    71,    72,    52,    54,
      53,    77,    78,    86,    88,   128,    17,   128,   128,     7,
     128,    80,   128,   128,   133,    81,   127,   128,   112,   113,
      88,   133,   127,    88,   109,    81,    81,    81,   110,   111,
      82,    89,   104,    81,    85,   126,   127,     3,   106,   115,
     115,   115,   116,   116,   117,   117,   118,   118,   118,   118,
     119,   119,   120,   121,   122,   123,   124,   126,   127,    12,
      81,    81,   114,   126,    81,   114,   114,   114,   127,   106,
     104,    83,    60,    81,    80,    81,    86,    81,    81,    81,
      83,    59,    60,   126,   127,   126,   126,    81,    88
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 96 "c:\\Cvs\\sith\\cog.y"
    { yyval.Integer = yyvsp[0].Integer; ;}
    break;

  case 6:
#line 97 "c:\\Cvs\\sith\\cog.y"
    { yyval.Integer = yyvsp[0].Integer; ;}
    break;

  case 7:
#line 101 "c:\\Cvs\\sith\\cog.y"
    { yyval.Float = yyvsp[0].Float; ;}
    break;

  case 8:
#line 102 "c:\\Cvs\\sith\\cog.y"
    { yyval.Float = yyvsp[0].Double; ;}
    break;

  case 9:
#line 106 "c:\\Cvs\\sith\\cog.y"
    { yyval.String = yyvsp[0].String; ;}
    break;

  case 10:
#line 110 "c:\\Cvs\\sith\\cog.y"
    { yyval.Boolean = yyvsp[0].Boolean; ;}
    break;

  case 11:
#line 114 "c:\\Cvs\\sith\\cog.y"
    { yyval.Float = yyvsp[0].Float; ;}
    break;

  case 12:
#line 115 "c:\\Cvs\\sith\\cog.y"
    { yyval.Float = (float)yyvsp[0].Integer; ;}
    break;

  case 13:
#line 119 "c:\\Cvs\\sith\\cog.y"
    { yyVMTbuf = VMType((int)yyvsp[0].Integer); ;}
    break;

  case 14:
#line 120 "c:\\Cvs\\sith\\cog.y"
    { yyVMTbuf = VMType((bool)yyvsp[0].Boolean); ;}
    break;

  case 15:
#line 121 "c:\\Cvs\\sith\\cog.y"
    { yyVMTbuf = VMType((float)yyvsp[0].Float); ;}
    break;

  case 16:
#line 123 "c:\\Cvs\\sith\\cog.y"
    {
			std::string StrTmp = std::string(yyvsp[0].String);
			std::string StrBuf;
			// Translate and output STRING LITERALS:
			int i = 1;
			while(StrTmp[i] != '\"' && StrTmp[i] != '\0')
			{
				if(StrTmp[i] == '\\')
				{
					++i;
					if(StrTmp[i] == 'n')
					{
						StrBuf.push_back('\n');
					}
					else if(StrTmp[i] == '\"')
					{
						StrBuf.push_back('\"');
					}
					else if(StrTmp[i] == 't')
					{
						StrBuf.push_back('\t');
					}
					else if(StrTmp[i] == '\\')
					{
						StrBuf.push_back('\\');
					}
					else if(StrTmp[i] == '\0')
					{
						break;
					}
					
					++i;
					continue;
				}
				else
				{
					StrBuf.push_back(StrTmp[i++]);
					continue;
				};
			};
			yyVMTbuf = VMType(StrBuf);
			free(yyvsp[0].String);
		;}
    break;

  case 17:
#line 167 "c:\\Cvs\\sith\\cog.y"
    {
			yyVMTbuf = VMType(Sith::Math::Vector(yyvsp[-3].Float, yyvsp[-2].Float, yyvsp[-1].Float));
		;}
    break;

  case 18:
#line 173 "c:\\Cvs\\sith\\cog.y"
    { yyval.String = yyvsp[0].String ;}
    break;

  case 19:
#line 178 "c:\\Cvs\\sith\\cog.y"
    {
							int HeapAddr = GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String);
							if(HeapAddr == -1)
							{
								yyerror("Unknown Identifier");
								free(yyvsp[0].String);
								return 1;
							};
							GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
							free(yyvsp[0].String);
						;}
    break;

  case 20:
#line 190 "c:\\Cvs\\sith\\cog.y"
    {
							int Scope = GlobalStackMachine->Heap.TranslateNamespaceName(yyvsp[-2].String);
							if(Scope == -1)
							{
								// Scope does not exist; add it
								Sith::COG::CogLib::InjectNamespace(yyvsp[-2].String);
								Scope = GlobalStackMachine->Heap.TranslateNamespaceName(yyvsp[-2].String);						
							}
							int Value = GlobalStackMachine->Heap.TranslateNamespaceHeapName(Scope, yyvsp[0].String);
							if(Value == -1)
							{
								// Variable does not exist; add it
								std::stringstream VarName;
								VarName << yyvsp[-2].String << "::" << yyvsp[0].String;
								Sith::COG::CogLib::AddSetting(VarName.str(), Sith::COG::VMType(Sith::COG::VMTC_VOID));
								
								Value = GlobalStackMachine->Heap.TranslateNamespaceHeapName(Scope, yyvsp[0].String);
							};
							GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, Value, Scope), COGlineno);
							free(yyvsp[-2].String);
							free(yyvsp[0].String);
						;}
    break;

  case 21:
#line 212 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::PUSH, VMType(yyVMTbuf), COGlineno); ;}
    break;

  case 24:
#line 219 "c:\\Cvs\\sith\\cog.y"
    {
							GlobalStackMachine->AddInstruction(Opcodes::ILOD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-3].String), -1), COGlineno);
						;}
    break;

  case 25:
#line 223 "c:\\Cvs\\sith\\cog.y"
    {
							GlobalStackMachine->AddInstruction(Opcodes::SYSCALL, VMType(VMTC_SYSTEM_CALL, 2, -1), COGlineno);
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 26:
#line 228 "c:\\Cvs\\sith\\cog.y"
    {
							GlobalStackMachine->AddInstruction(Opcodes::SYSCALL, VMType(VMTC_SYSTEM_CALL, 0, -1), COGlineno);
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 27:
#line 233 "c:\\Cvs\\sith\\cog.y"
    {
							GlobalStackMachine->AddInstruction(Opcodes::SYSCALL, VMType(VMTC_SYSTEM_CALL, 1, -1), COGlineno);
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 28:
#line 237 "c:\\Cvs\\sith\\cog.y"
    { RecurArgCtr.push(yyArgCtr); yyArgCtr = 0; ;}
    break;

  case 29:
#line 238 "c:\\Cvs\\sith\\cog.y"
    {
							if(yyArgCtr != 1)
							{
								std::ostringstream Stream;
								Stream << "WARNING: System call \'getparam\' does not take " << yyArgCtr << " arguments.\n";
								ConOut(Stream.str(), ConOut::Warning);
								YYABORT;
							};
							
							yyArgCtr = RecurArgCtr.top();
							RecurArgCtr.pop();
							
							GlobalStackMachine->AddInstruction(Opcodes::SYSCALL, VMType(VMTC_SYSTEM_CALL, 4, -1), COGlineno);
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 30:
#line 253 "c:\\Cvs\\sith\\cog.y"
    { RecurArgCtr.push(yyArgCtr); yyArgCtr = 0; ;}
    break;

  case 31:
#line 254 "c:\\Cvs\\sith\\cog.y"
    {
							if(yyArgCtr != 1)
							{
								std::ostringstream Stream;
								Stream << "WARNING: System call \'returnex\' does not take " << yyArgCtr << " arguments.\n";
								ConOut(Stream.str(), ConOut::Warning);
								YYABORT;
							};
							
							yyArgCtr = RecurArgCtr.top();
							RecurArgCtr.pop();
							
							GlobalStackMachine->AddInstruction(Opcodes::SYSCALL, VMType(VMTC_SYSTEM_CALL, 5, -1), COGlineno);
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 32:
#line 269 "c:\\Cvs\\sith\\cog.y"
    { RecurArgCtr.push(yyArgCtr); yyArgCtr = 0; ;}
    break;

  case 33:
#line 270 "c:\\Cvs\\sith\\cog.y"
    {
							if(yyArgCtr != 1)
							{
								std::ostringstream Stream;
								Stream << "WARNING: System call \'sleep\' does not take " << yyArgCtr << " arguments.\n";
								ConOut(Stream.str(), ConOut::Warning);
								YYABORT;
							};
							
							yyArgCtr = RecurArgCtr.top();
							RecurArgCtr.pop();
							
							GlobalStackMachine->AddInstruction(Opcodes::SYSCALL, VMType(VMTC_SYSTEM_CALL, 3, -1), COGlineno);
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 34:
#line 285 "c:\\Cvs\\sith\\cog.y"
    { RecurArgCtr.push(yyArgCtr); yyArgCtr = 0; ;}
    break;

  case 35:
#line 286 "c:\\Cvs\\sith\\cog.y"
    {
							int LibOff = CogLib::TranslateLibraryName(yyvsp[-3].String, yyArgCtr);
							if(LibOff == -1)
							{
								std::ostringstream Stream;
								Stream << "WARNING: Library function \'" << yyvsp[-3].String << "\' does not exist or it does not take " << yyArgCtr << " arguments.\n";
								ConOut(Stream.str(), ConOut::Warning);
								YYABORT;
							}
							else
							{
								GlobalStackMachine->AddInstruction(Opcodes::LIBCALL, VMType(VMTC_LIBRARY_CALL, LibOff, -1), COGlineno);
							};
						
							yyArgCtr = RecurArgCtr.top();
							RecurArgCtr.pop();
							
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 36:
#line 305 "c:\\Cvs\\sith\\cog.y"
    { RecurArgCtr.push(yyArgCtr); yyArgCtr = 0; ;}
    break;

  case 37:
#line 306 "c:\\Cvs\\sith\\cog.y"
    {
							int LibOff = CogLib::TranslateLibraryName(yyvsp[-4].String, yyArgCtr);
							if(LibOff == -1)
							{
								std::ostringstream Stream;
								Stream << "WARNING: Library function \'" << yyvsp[-4].String << "\' does not exist or it does not take " << yyArgCtr << " arguments.\n";
								ConOut(Stream.str(), ConOut::Warning);
								YYABORT;
							}
							else
							{
								GlobalStackMachine->AddInstruction(Opcodes::LIBCALL, VMType(VMTC_LIBRARY_CALL, LibOff, -1), COGlineno);
							};
														
							yyArgCtr = RecurArgCtr.top();
							RecurArgCtr.pop();
							
							GlobalStackMachine->AddInstruction(Opcodes::RPSH, VMType(VMTC_VOID), COGlineno);
						;}
    break;

  case 38:
#line 326 "c:\\Cvs\\sith\\cog.y"
    {
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::INC, VMType(VMTC_VOID), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::STOR, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
				;}
    break;

  case 39:
#line 333 "c:\\Cvs\\sith\\cog.y"
    {
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::DEC, VMType(VMTC_VOID), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::STOR, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
				;}
    break;

  case 40:
#line 339 "c:\\Cvs\\sith\\cog.y"
    { /* eat it */ ;}
    break;

  case 41:
#line 340 "c:\\Cvs\\sith\\cog.y"
    { /* eat it */ ;}
    break;

  case 42:
#line 344 "c:\\Cvs\\sith\\cog.y"
    { ++yyArgCtr; ;}
    break;

  case 43:
#line 345 "c:\\Cvs\\sith\\cog.y"
    { ++yyArgCtr; ;}
    break;

  case 45:
#line 351 "c:\\Cvs\\sith\\cog.y"
    {
					GlobalStackMachine->AddInstruction(Opcodes::PUSH, VMType(-1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::MUL, VMType(VMTC_VOID), COGlineno);
				;}
    break;

  case 46:
#line 355 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::NOT, VMType(VMTC_VOID), COGlineno); ;}
    break;

  case 47:
#line 357 "c:\\Cvs\\sith\\cog.y"
    {
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::INC, VMType(VMTC_VOID), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::STOR, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
				;}
    break;

  case 48:
#line 364 "c:\\Cvs\\sith\\cog.y"
    {
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::DEC, VMType(VMTC_VOID), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::STOR, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
					GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[0].String), -1), COGlineno);
				;}
    break;

  case 50:
#line 374 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::MUL, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 51:
#line 375 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::DIV, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 52:
#line 376 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::MOD, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 54:
#line 381 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::ADD, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 55:
#line 382 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::SUB, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 57:
#line 387 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::SHL, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 58:
#line 388 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::SHR, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 60:
#line 393 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CLT, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 61:
#line 394 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CGT, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 62:
#line 395 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CLTE, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 63:
#line 396 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CGTE, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 65:
#line 401 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CE, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 66:
#line 402 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CNE, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 68:
#line 407 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::AND, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 70:
#line 412 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::XOR, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 72:
#line 417 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::OR, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 74:
#line 422 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::CAND, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 76:
#line 427 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::COR, VMType(VMTC_VOID), COGlineno) ;}
    break;

  case 78:
#line 433 "c:\\Cvs\\sith\\cog.y"
    {
								GlobalStackMachine->AddInstruction(Opcodes::ISTR, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-5].String), -1), COGlineno);
							;}
    break;

  case 79:
#line 437 "c:\\Cvs\\sith\\cog.y"
    {
								GlobalStackMachine->AddInstruction(Opcodes::STOR, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-2].String), -1), COGlineno);
								GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-2].String), -1), COGlineno);
							;}
    break;

  case 80:
#line 442 "c:\\Cvs\\sith\\cog.y"
    {
								int Scope = GlobalStackMachine->Heap.TranslateNamespaceName(yyvsp[-4].String);
								if(Scope == -1)
								{
									yyerror("Scope does not exist");
									return 1;
								}
								int Value = GlobalStackMachine->Heap.TranslateNamespaceHeapName(Scope, yyvsp[-2].String);
								if(Value == -1)
								{
									yyerror("Unknown Identifier");
									return 1;
								};
								GlobalStackMachine->AddInstruction(Opcodes::STOR, VMType(VMTC_HEAP_ADDRESS, Value, Scope), COGlineno);
								GlobalStackMachine->AddInstruction(Opcodes::LOAD, VMType(VMTC_HEAP_ADDRESS, Value, Scope), COGlineno);
							;}
    break;

  case 89:
#line 476 "c:\\Cvs\\sith\\cog.y"
    {
				int LocalHeapAddr = GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String);
				if(LocalHeapAddr == -1)
				{
					GlobalStackMachine->Heap.AddLocal(std::string(yyvsp[-1].String), VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1));
				}
				else
				{
					GlobalStackMachine->Heap.Set(GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1));
				};
			;}
    break;

  case 96:
#line 506 "c:\\Cvs\\sith\\cog.y"
    {
				Opcode Temp = GlobalStackMachine->Code[GlobalStackMachine->InstructionCount - 1].OPCODE;
				if((Temp == Opcodes::PUSH) || (Temp == Opcodes::LOAD) || (Temp == Opcodes::RPSH))
				{
					GlobalStackMachine->RemoveInstruction(); /* Remove last PUSH/LOAD/RPSH instruction */
				}
			;}
    break;

  case 97:
#line 517 "c:\\Cvs\\sith\\cog.y"
    {
				yyval.Integer = GlobalStackMachine->AddInstruction(Opcodes::JNT, VMType(VMTC_VOID), COGlineno); // Placeholder, return back placeholder address
			;}
    break;

  case 98:
#line 524 "c:\\Cvs\\sith\\cog.y"
    {
				BackPatchStack.push(GlobalStackMachine->InstructionCount);
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_VOID), COGlineno);	// Placeholder for jump to end
				BackPatchStack.push(1);	// Back patch counter
				yyval.Integer = yyvsp[-1].Integer; // return back JNT
			;}
    break;

  case 99:
#line 534 "c:\\Cvs\\sith\\cog.y"
    {
				GlobalStackMachine->Code[yyvsp[-1].Integer] = Instruction(Opcodes::JNT, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[yyvsp[-1].Integer].LineNumber);
			;}
    break;

  case 100:
#line 541 "c:\\Cvs\\sith\\cog.y"
    {
				GlobalStackMachine->Code[yyvsp[0].Integer] = Instruction(Opcodes::JNT, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount - 1, -1), GlobalStackMachine->Code[yyvsp[0].Integer].LineNumber);
				int BackPatchCount = BackPatchStack.top(); BackPatchStack.pop();
				
				for(int i = 0; i < BackPatchCount; ++i)
				{
					GlobalStackMachine->Code[BackPatchStack.top()] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount - 1, -1), GlobalStackMachine->Code[BackPatchStack.top()].LineNumber);
					BackPatchStack.pop();
				};
				
				GlobalStackMachine->RemoveInstruction(); // Remove last JMP
			;}
    break;

  case 101:
#line 554 "c:\\Cvs\\sith\\cog.y"
    {
				int BackPatchCount = BackPatchStack.top(); BackPatchStack.pop();
				
				for(int i = 0; i < BackPatchCount; ++i)
				{
					GlobalStackMachine->Code[BackPatchStack.top()] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[BackPatchStack.top()].LineNumber);
					BackPatchStack.pop();
				};
			;}
    break;

  case 102:
#line 566 "c:\\Cvs\\sith\\cog.y"
    { BackPatchStack.push(GlobalStackMachine->InstructionCount); ;}
    break;

  case 103:
#line 571 "c:\\Cvs\\sith\\cog.y"
    {
				BackPatchStack.push(GlobalStackMachine->InstructionCount); // Push back address of JNT
				BackPatchStack.push(0); // Add the end-patch counter
				GlobalStackMachine->AddInstruction(Opcodes::JNT, VMType(VMTC_VOID), COGlineno); // Placeholder
			;}
    break;

  case 104:
#line 580 "c:\\Cvs\\sith\\cog.y"
    {
				BackPatchStack.push(GlobalStackMachine->InstructionCount); // return start of loop
				BackPatchStack.push(0); // add end-patch counter
			;}
    break;

  case 105:
#line 588 "c:\\Cvs\\sith\\cog.y"
    {
				BackPatchStack.push(GlobalStackMachine->InstructionCount); // return start of loop before conditional
			;}
    break;

  case 106:
#line 595 "c:\\Cvs\\sith\\cog.y"
    {
				BackPatchStack.push(GlobalStackMachine->InstructionCount); // return JNT offset
				GlobalStackMachine->AddInstruction(Opcodes::JNT, VMType(VMTC_VOID), COGlineno); // placeholder
				BackPatchStack.push(GlobalStackMachine->InstructionCount); // return JMP offset
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_VOID), COGlineno); // this should jump to EXECUTION STATEMENT
				BackPatchStack.push(GlobalStackMachine->InstructionCount); // return address of first instruction of iteration statement
			;}
    break;

  case 107:
#line 606 "c:\\Cvs\\sith\\cog.y"
    {
				int ItOff = BackPatchStack.top(); BackPatchStack.pop();
				int JMPOff = BackPatchStack.top(); BackPatchStack.pop();
				int JNTOff = BackPatchStack.top(); BackPatchStack.pop();
				int StartOff = BackPatchStack.top(); BackPatchStack.pop();
				
				// Add jump to beginning right after expression
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, StartOff, -1), COGlineno);
				
				// Execution block is immediately after this instruction
				
				// Patch back execution address
				GlobalStackMachine->Code[JMPOff] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[JMPOff].LineNumber);
				
				// Push remaining values back onto the back-patch stack
				BackPatchStack.push(ItOff);
				BackPatchStack.push(JNTOff);
				BackPatchStack.push(0); // Add the back-patch counter
			;}
    break;

  case 108:
#line 626 "c:\\Cvs\\sith\\cog.y"
    {
				// Pop off pointless backpatch
				BackPatchStack.pop();
				
				// Execution block is immediately after this instruction
				
				// Patch back execution address
				GlobalStackMachine->Code[BackPatchStack.top()] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[BackPatchStack.top()].LineNumber);
				BackPatchStack.pop();
				
				BackPatchStack.push(0); // Add the back-patch counter
			;}
    break;

  case 109:
#line 642 "c:\\Cvs\\sith\\cog.y"
    {
				int EndCnt = BackPatchStack.top(); BackPatchStack.pop();
				std::stack<int> EndPatchStack;
				int i;
				for(i = 0; i < EndCnt; ++i)
				{
					EndPatchStack.push(BackPatchStack.top());
					BackPatchStack.pop();
				};
				
				int JNTOff = BackPatchStack.top(); BackPatchStack.pop();
				
				// Add jump back to start of loop
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, BackPatchStack.top(), -1), COGlineno); BackPatchStack.pop();
				
				// Set JNT to end of loop
				GlobalStackMachine->Code[JNTOff] = Instruction(Opcodes::JNT, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[JNTOff].LineNumber);
				
				for(i = 0; i < EndCnt; ++i)
				{
					// Back-patch breaks
					GlobalStackMachine->Code[EndPatchStack.top()] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[EndPatchStack.top()].LineNumber);
					EndPatchStack.pop();
				};
			;}
    break;

  case 110:
#line 668 "c:\\Cvs\\sith\\cog.y"
    {
				int EndCnt = BackPatchStack.top(); BackPatchStack.pop();
				std::stack<int> EndPatchStack;
				int i;
				for(i = 0; i < EndCnt; ++i)
				{
					EndPatchStack.push(BackPatchStack.top());
					BackPatchStack.pop();
				};
				
				// Add jump back to start of loop
				GlobalStackMachine->AddInstruction(Opcodes::JT, VMType(VMTC_INSTRUCTION_ADDRESS, BackPatchStack.top(), -1), COGlineno); BackPatchStack.pop();
				
				for(i = 0; i < EndCnt; ++i)
				{
					// Back-patch breaks
					GlobalStackMachine->Code[EndPatchStack.top()] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[EndPatchStack.top()].LineNumber);
					EndPatchStack.pop();
				};
			;}
    break;

  case 111:
#line 689 "c:\\Cvs\\sith\\cog.y"
    {
				int EndCnt = BackPatchStack.top(); BackPatchStack.pop();
				std::stack<int> EndPatchStack;
				int i;
				for(i = 0; i < EndCnt; ++i)
				{
					EndPatchStack.push(BackPatchStack.top());
					BackPatchStack.pop();
				};
				
				int JNTOff = BackPatchStack.top(); BackPatchStack.pop();
				
				// Add jump back to start of iterator
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, BackPatchStack.top(), -1), COGlineno); BackPatchStack.pop();
				
				// Back patch JNT instruction
				GlobalStackMachine->Code[JNTOff] = Instruction(Opcodes::JNT, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[JNTOff].LineNumber);
				
				// Back patch breaks
				for(i = 0; i < EndCnt; ++i)
				{
					GlobalStackMachine->Code[EndPatchStack.top()] = Instruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, GlobalStackMachine->InstructionCount, -1), GlobalStackMachine->Code[EndPatchStack.top()].LineNumber);
					EndPatchStack.pop();
				};
			;}
    break;

  case 112:
#line 718 "c:\\Cvs\\sith\\cog.y"
    {
				int EndCnt = BackPatchStack.top(); BackPatchStack.pop();
				std::stack<int> EndPatchStack;
				int i;
				for(i = 0; i < EndCnt; ++i)
				{
					EndPatchStack.push(BackPatchStack.top());
					BackPatchStack.pop();
				}; // Take the end-patches off the backpatchstack
				
				int JNTOff = BackPatchStack.top(); BackPatchStack.pop();
				
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_INSTRUCTION_ADDRESS, BackPatchStack.top(), -1), COGlineno);
				
				BackPatchStack.push(JNTOff);
				
				// Put the end-patches back on the backpatchstack
				for(i = 0; i < EndCnt; ++i)
				{
					BackPatchStack.push(EndPatchStack.top());
					EndPatchStack.pop();
				};
				
				BackPatchStack.push(EndCnt); // Put the endpatch counter back on
			;}
    break;

  case 113:
#line 744 "c:\\Cvs\\sith\\cog.y"
    {
				int EndCnt = BackPatchStack.top(); BackPatchStack.pop();
				BackPatchStack.push(GlobalStackMachine->InstructionCount);
				GlobalStackMachine->AddInstruction(Opcodes::JMP, VMType(VMTC_VOID), COGlineno);
				BackPatchStack.push(++EndCnt);
			;}
    break;

  case 114:
#line 750 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::RETURN, VMType(VMTC_VOID), COGlineno); ;}
    break;

  case 115:
#line 751 "c:\\Cvs\\sith\\cog.y"
    { GlobalStackMachine->AddInstruction(Opcodes::RETURN, VMType(VMTC_VOID), COGlineno); ;}
    break;

  case 116:
#line 753 "c:\\Cvs\\sith\\cog.y"
    {
				int LocalHeapAddr = GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String);
				if(LocalHeapAddr == -1)
				{
					GlobalStackMachine->Heap.AddLocal(std::string(yyvsp[-1].String), VMType(yyVMTbuf), ExtTab);
				};
				
				GlobalStackMachine->AddInstruction(Opcodes::MSGCALL, VMType(VMTC_HEAP_ADDRESS, GlobalStackMachine->Heap.TranslateLocalHeapName(yyvsp[-1].String), -1), COGlineno);
			;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2370 "cog.y.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 766 "c:\\Cvs\\sith\\cog.y"


int yyerror(char* s)
{
	extern int COGlineno;	// defined in lex.c
	
	std::stringstream ErrorString;
	ErrorString << "ERROR: \"" << std::string(s) << "\" on line " << COGlineno << "\n";
	ConOut(ErrorString.str(), ConOut::Error);
	
	while(!RecurArgCtr.empty())
	{
		RecurArgCtr.pop();
	};
	
	yyArgCtr = 0;
	
	while(!BackPatchStack.empty())
	{
		BackPatchStack.pop();
	};
	
	return 1;
};
