/***************************************************************************
 *   Copyright (C) 2005 by Jonathan Clark                                  *
 *   Copyright (C) 2005 by The Sith 2 Project                              *
 *   captain.cliche@gmail.com                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "stdafx.h"
#include "uiwin.h"

Sith::UI::Window::Window()
{
	SetColorState(UICS_FLAT);
	SetColor(StandardColors::LightGrey);

	TitleBar = &CreateChild();
	TitleBar->SetPosition(2, 2);
	TitleBar->SetSize(26, 24);
	TitleBar->SetRectState(UIRS_TOPLEFT);
	TitleBar->SetColorState(UICS_LRGRADIENT);
	TitleBar->SetColor(StandardColors::Blue, 1);
	TitleBar->SetColor(StandardColors::Green, 2);
	TitleBar->SetText("Default");
	TitleBar->SetFont("med1.sft");

	ClientArea = &CreateChild();
};

Sith::UI::Window::~Window()
{
	return;
};
